var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _HighlightOverlay_instances, _HighlightOverlay_context, _HighlightOverlay_elementsBounds, _HighlightOverlay_elements, _HighlightOverlay_params, _HighlightOverlay_cursor, _HighlightOverlay_mouseHandler, _HighlightOverlay_lastTime, _HighlightOverlay_timer, _HighlightOverlay_animation, _HighlightOverlay_backdropColor, _HighlightOverlay_backdropIncrement, _HighlightOverlay_isVisible, _HighlightOverlay_isAnimated, _HighlightOverlay_calculateBackdropIncrement, _HighlightOverlay_increaseBackdropValues, _HighlightOverlay_draw, _HighlightOverlay_updateCursor, _HighlightOverlay_handleClick, _HighlightOverlay_animate, _HighlightOverlay_calculateBounds, _HighlightOverlay_onResize;
import MouseHandler from './MouseHandler';
import BackDropContext from './BackDropContext';
import { CloseTypes } from './interfaces/enums';
const defaultOptions = {
    offset: 3,
    duration: 100,
    close: CloseTypes.ALWAYS,
    backDropColor: [0, 0, 0, 0.3],
    cursor: {
        enabled: false,
        size: 15,
    },
    resizeDebounce: 300,
};
class HighlightOverlay {
    constructor(params) {
        _HighlightOverlay_instances.add(this);
        _HighlightOverlay_context.set(this, void 0);
        _HighlightOverlay_elementsBounds.set(this, void 0);
        _HighlightOverlay_elements.set(this, void 0);
        _HighlightOverlay_params.set(this, void 0);
        _HighlightOverlay_cursor.set(this, void 0);
        _HighlightOverlay_mouseHandler.set(this, void 0);
        _HighlightOverlay_lastTime.set(this, void 0);
        _HighlightOverlay_timer.set(this, void 0);
        _HighlightOverlay_animation.set(this, void 0);
        _HighlightOverlay_backdropColor.set(this, void 0);
        _HighlightOverlay_backdropIncrement.set(this, void 0);
        _HighlightOverlay_isVisible.set(this, void 0);
        __classPrivateFieldSet(this, _HighlightOverlay_context, new BackDropContext(__classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_onResize).bind(this), params.resizeDebounce), "f");
        __classPrivateFieldSet(this, _HighlightOverlay_params, { ...defaultOptions, ...params, cursor: { ...defaultOptions.cursor, ...params?.cursor } }, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_elementsBounds, [], "f");
        __classPrivateFieldSet(this, _HighlightOverlay_cursor, { x: 0, y: 0 }, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_timer, 0, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_lastTime, 0, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_backdropColor, [0, 0, 0, 0], "f");
        __classPrivateFieldSet(this, _HighlightOverlay_backdropIncrement, [], "f");
        __classPrivateFieldSet(this, _HighlightOverlay_mouseHandler, new MouseHandler({
            cursorMonitoring: __classPrivateFieldGet(this, _HighlightOverlay_params, "f").cursor.enabled,
            onMove: __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_updateCursor).bind(this),
            onClick: __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_handleClick).bind(this),
        }), "f");
        __classPrivateFieldSet(this, _HighlightOverlay_isVisible, false, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_backdropIncrement, __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_calculateBackdropIncrement).call(this), "f");
    }
    show(elements) {
        __classPrivateFieldSet(this, _HighlightOverlay_elements, elements, "f");
        __classPrivateFieldSet(this, _HighlightOverlay_elementsBounds, [], "f");
        __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_calculateBounds).call(this);
        __classPrivateFieldGet(this, _HighlightOverlay_context, "f").show();
        __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_animate).call(this);
        __classPrivateFieldGet(this, _HighlightOverlay_mouseHandler, "f").mount();
    }
    hide() {
        __classPrivateFieldSet(this, _HighlightOverlay_backdropColor, [0, 0, 0, 0], "f");
        __classPrivateFieldSet(this, _HighlightOverlay_isVisible, false, "f");
        __classPrivateFieldGet(this, _HighlightOverlay_context, "f").hide();
        __classPrivateFieldGet(this, _HighlightOverlay_mouseHandler, "f").unmount();
        cancelAnimationFrame(__classPrivateFieldGet(this, _HighlightOverlay_animation, "f"));
    }
}
_HighlightOverlay_context = new WeakMap(), _HighlightOverlay_elementsBounds = new WeakMap(), _HighlightOverlay_elements = new WeakMap(), _HighlightOverlay_params = new WeakMap(), _HighlightOverlay_cursor = new WeakMap(), _HighlightOverlay_mouseHandler = new WeakMap(), _HighlightOverlay_lastTime = new WeakMap(), _HighlightOverlay_timer = new WeakMap(), _HighlightOverlay_animation = new WeakMap(), _HighlightOverlay_backdropColor = new WeakMap(), _HighlightOverlay_backdropIncrement = new WeakMap(), _HighlightOverlay_isVisible = new WeakMap(), _HighlightOverlay_instances = new WeakSet(), _HighlightOverlay_isAnimated = function _HighlightOverlay_isAnimated() {
    return __classPrivateFieldGet(this, _HighlightOverlay_backdropColor, "f").every((value, index) => value >= __classPrivateFieldGet(this, _HighlightOverlay_params, "f").backDropColor[index]);
}, _HighlightOverlay_calculateBackdropIncrement = function _HighlightOverlay_calculateBackdropIncrement() {
    const numberOfIterations = __classPrivateFieldGet(this, _HighlightOverlay_params, "f").duration / HighlightOverlay.FRAME_INTERVAL;
    return __classPrivateFieldGet(this, _HighlightOverlay_params, "f").backDropColor.map((value) => value / numberOfIterations);
}, _HighlightOverlay_increaseBackdropValues = function _HighlightOverlay_increaseBackdropValues() {
    return __classPrivateFieldGet(this, _HighlightOverlay_backdropColor, "f").map((value, index) => {
        if (value < __classPrivateFieldGet(this, _HighlightOverlay_params, "f").backDropColor[index]) {
            return value + __classPrivateFieldGet(this, _HighlightOverlay_backdropIncrement, "f")[index];
        }
        return value;
    });
}, _HighlightOverlay_draw = function _HighlightOverlay_draw() {
    const ctx = __classPrivateFieldGet(this, _HighlightOverlay_context, "f").getCtx();
    const width = __classPrivateFieldGet(this, _HighlightOverlay_context, "f").getWidth();
    const height = __classPrivateFieldGet(this, _HighlightOverlay_context, "f").getHeight();
    ctx.clearRect(0, 0, width, height);
    ctx.beginPath();
    ctx.fillStyle = `rgba(${__classPrivateFieldGet(this, _HighlightOverlay_backdropColor, "f").toString()})`;
    ctx.globalCompositeOperation = 'source-over';
    ctx.fillRect(0, 0, width, height);
    ctx.globalCompositeOperation = 'destination-out';
    ctx.fillStyle = 'black';
    __classPrivateFieldGet(this, _HighlightOverlay_elementsBounds, "f").forEach((element) => {
        ctx.fillRect(element.x, element.y, element.width, element.height);
    });
    ctx.stroke();
    if (__classPrivateFieldGet(this, _HighlightOverlay_params, "f").cursor.enabled) {
        ctx.arc(__classPrivateFieldGet(this, _HighlightOverlay_cursor, "f").x, __classPrivateFieldGet(this, _HighlightOverlay_cursor, "f").y, __classPrivateFieldGet(this, _HighlightOverlay_params, "f").cursor.size, 0, 2 * Math.PI);
        ctx.fill();
    }
}, _HighlightOverlay_updateCursor = function _HighlightOverlay_updateCursor(x, y) {
    __classPrivateFieldGet(this, _HighlightOverlay_cursor, "f").x = x;
    __classPrivateFieldGet(this, _HighlightOverlay_cursor, "f").y = y;
    __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_draw).call(this);
}, _HighlightOverlay_handleClick = function _HighlightOverlay_handleClick(event) {
    if (!__classPrivateFieldGet(this, _HighlightOverlay_isVisible, "f")) {
        return;
    }
    switch (__classPrivateFieldGet(this, _HighlightOverlay_params, "f").close) {
        case CloseTypes.NONE:
            return;
        case CloseTypes.ALWAYS:
            return this.hide();
        case CloseTypes.BACKDROP:
            const alpha = __classPrivateFieldGet(this, _HighlightOverlay_context, "f").getCtx().getImageData(event.clientX, event.clientY, 1, 1).data[3];
            if (alpha !== 0) {
                this.hide();
            }
            return;
    }
}, _HighlightOverlay_animate = function _HighlightOverlay_animate(timestamp = 0) {
    const deltaTime = timestamp - __classPrivateFieldGet(this, _HighlightOverlay_lastTime, "f");
    if (__classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_isAnimated).call(this)) {
        __classPrivateFieldSet(this, _HighlightOverlay_isVisible, true, "f");
        cancelAnimationFrame(__classPrivateFieldGet(this, _HighlightOverlay_animation, "f"));
    }
    if (__classPrivateFieldGet(this, _HighlightOverlay_timer, "f") > HighlightOverlay.FRAME_INTERVAL) {
        __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_draw).call(this);
        __classPrivateFieldSet(this, _HighlightOverlay_backdropColor, __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_increaseBackdropValues).call(this), "f");
        __classPrivateFieldSet(this, _HighlightOverlay_timer, 0, "f");
    }
    else {
        __classPrivateFieldSet(this, _HighlightOverlay_timer, __classPrivateFieldGet(this, _HighlightOverlay_timer, "f") + deltaTime, "f");
    }
    __classPrivateFieldSet(this, _HighlightOverlay_lastTime, timestamp, "f");
    __classPrivateFieldSet(this, _HighlightOverlay_animation, requestAnimationFrame(__classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_animate).bind(this)), "f");
}, _HighlightOverlay_calculateBounds = function _HighlightOverlay_calculateBounds() {
    for (let i = 0; i < __classPrivateFieldGet(this, _HighlightOverlay_elements, "f").length; i++) {
        const element = __classPrivateFieldGet(this, _HighlightOverlay_elements, "f")[i];
        const rect = element.getBoundingClientRect();
        __classPrivateFieldGet(this, _HighlightOverlay_elementsBounds, "f").push({
            ...rect,
            x: rect.x - __classPrivateFieldGet(this, _HighlightOverlay_params, "f").offset,
            y: rect.y - __classPrivateFieldGet(this, _HighlightOverlay_params, "f").offset,
            width: rect.width + __classPrivateFieldGet(this, _HighlightOverlay_params, "f").offset * 2,
            height: rect.height + __classPrivateFieldGet(this, _HighlightOverlay_params, "f").offset * 2,
        });
    }
}, _HighlightOverlay_onResize = function _HighlightOverlay_onResize() {
    __classPrivateFieldSet(this, _HighlightOverlay_elementsBounds, [], "f");
    __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_calculateBounds).call(this);
    __classPrivateFieldGet(this, _HighlightOverlay_instances, "m", _HighlightOverlay_draw).call(this);
};
HighlightOverlay.FRAME_INTERVAL = 1000 / 60;
export default HighlightOverlay;
//# sourceMappingURL=HighlightOverlay.js.map